// FILE:      BrailleConverter.h
// AUTHOR:    Daniel Lee
// PURPOSE:   
// REFERENCE: None. 
// COMMENTS:  
// REQUIRES:  BrailleTranslator.h, Speech.h, TranslationConfig.h
// Last Mod:  27-07-2006




#import <Cocoa/Cocoa.h>
#import <Foundation/NSString.h>
#import <AppKit/NSNibLoading.h>
#import "BrailleTranslator.h"
#import "Speech.h"

@interface BrailleConverter : NSObject
{
	IBOutlet id brailleMenu;

    IBOutlet NSTextView *inputTextView;
    IBOutlet NSTextView *brailleTextView;
    IBOutlet NSTextView *asciiTextView;

    IBOutlet Speech *speechObject;
    IBOutlet BrailleTranslator *translatorObject;
	
	IBOutlet NSTextField *errorMessage;
    IBOutlet NSWindow *errorWindow;
    IBOutlet NSWindow *mainWindow;	
}

// tempName used to add on the absolute path before the final build
// Need to remove @ final build
NSString *tempName = @"/Users/daniellee/FinalYearProject/";

NSString * const tagTable = @"/Users/daniellee/FinalYearProject/tag_table.ini";
int const tagLengthLimit = 5;
NSString * const tagLengthLimitName = @"5";
BOOL oldDirection;    // To stop the speech from occuring at each keystroke

NSString *language;
BOOL translateToBraille;
NSMutableArray *tagsArray;
NSMutableArray *forwardFileArray;
NSMutableArray *reverseFileArray;

- (void) loadTags;
- (void) quit: (NSString *) string;
- (IBAction) setBrailleTag: (id) sender;
- (IBAction) errorOK: (id) sender;

- (void) textDidChange: (NSNotification *) aNotification;
- (void) textViewDidChangeSelection: (NSNotification *) aNotification;

@end