// FILE:      BrailleTranslator.h
// AUTHOR:    Daniel Lee
// PURPOSE:   
// REFERENCE: None. 
// COMMENTS:  
// REQUIRES:  Nil
// Last Mod:  27-07-2006




#import <Cocoa/Cocoa.h>
#import <stdio.h>
#import <stdlib.h>
#import <string.h>
#import <ctype.h>


/***********************    Constant Macros        *********************************************/
#define RULESIZE 50                    // maximum length of a rule
#define FOCUSSIZE 20                // maximum length of a rule's focus
#define CONTEXTSIZE 10                // maximum length of a rule's right context
#define OUTSIZE 25                    // maximum length of a rule's output
#define NO_RIGHT_CONTEXT "]="        // used to determine when there is no right context
#define OUTPUT_SIZE 256                // max length of a translated word
#define INPUT_SIZE 256                // max length of a braille input word to be translated
#define RULE_ARRAY_SIZE 26


// Test for rules
#define RULES_PATH "/Users/daniellee/FinalYearProject/English to Braille lvl 2.txt"
#define RULES_PATH_B "/Users/daniellee/FinalYearProject/Braille to English lvl 2.txt"


@interface BrailleTranslator : NSObject
{
}


typedef struct myRule
{
    int input_class;
    char left_context[CONTEXTSIZE];        // structure holds all the information
    char focus[FOCUSSIZE];                // about a particular rule. This struct
    char right_context[CONTEXTSIZE];    // is used in a linked list hence the
    char output[OUTSIZE];                // last component is a link to the next
    int next_state;                        // rule in the list.
    struct myRule *next;
} rule_t;

rule_t *list_array[27];    // stores the head of each linked list where there is one list
                           // for each letter and another for all other characters
BOOL translateToBraille;
NSString *language;
int brailleGrade;

- (void) changeRules: (NSString *) grade;
- (NSString *) translateLine: (NSString *) input grade: (NSString *) grade direction: (BOOL) newTranslateToBraille;

// Common function for both directions
int HashFunction( char key );

// Methods for forward translation
void translateLineToBraille( char print_line[], char braille_line[] );
void constructRulesToBraille( char* location );
int CheckLeftCtxt( char left_ctxt[], char left_of_focus[] );
int CheckRightCtxt( char right_ctxt[], char right_of_focus[] );

// Methods for backward translation
void constructRulesFromBraille( char* location );
void translateLineFromBraille( char print_line[], char braille_line[] );


@end
