// FILE:      TranslationConfig.h
// AUTHOR:    Daniel Lee
// PURPOSE:   Header file for TranslationConfig.m
// REFERENCE: None. 
// COMMENTS:  
// REQUIRES:  BrailleTranslator.h, Sppech.h
// Last Mod:  24-03-2006




#import <Cocoa/Cocoa.h>
#import "BrailleTranslator.h"
#import "Speech.h"


@interface TranslationConfig : NSObject
{
    IBOutlet id brailleGradeMenu;
    IBOutlet NSPopUpButton *languageMenu;
    IBOutlet Speech *speechObject;
    IBOutlet id translationDirectionMatrix;
    IBOutlet BrailleTranslator *translationOjbect;

    NSString *language;
    BOOL translateToBraile;
    int brailleGrade;
}

	
- (BOOL) translateToBraile;
- (int) brailleGrade;
- (NSString*) language;

- (IBAction)setBrailleGrade:(id)sender;
- (IBAction)setLanguage:(id)sender;
- (IBAction)setTranslationDirection:(id)sender;


@end
